var system = require("../../../system");
var settings = require("../../../../config/settings");
const AppServiceBase = require("../../app.base");
const md5 = require('md5')

//阿里支付类
class utils360Sve extends AppServiceBase {
  constructor() {
      super();
      this.centerAppUrl = settings.centerAppUrl();
      this.utilsAuthSve = system.getObject("service.utilsSve.utilsAuthSve")
      this.pushlogSve = system.getObject("service.common.pushlogSve");
      this.utilsOrderSve = system.getObject("service.utilsSve.utilsOrderSve");
      this.utilsPushSve = system.getObject("service.utilsSve.utilsPushSve");
  }

  /**
  * 2020 1103 lin 磐农2.1 创建服务单
  * @param {*} pobj
  * @param {*} actionBody
  */
  async submitService(pobj, actionBody,req) {

    // 获取userpin 为什么在这里获取？原因：getWay获取不到手机号 再去调用其他接口浪费资源
    pobj.actionType = "getLoginByUserName";
    pobj.actionBody.channelUserId = actionBody.contactMobile; // 即：86_18512345678
    pobj.actionBody.userName = actionBody.contactMobile;
    pobj.actionBody.mobile = actionBody.contactMobile;
    // pobj.actionBody.userpin = pobj.actionBody.userpin || this.getUUID();//采用jwt方式封装userpin
    var tmpOpResult = await this.utilsAuthSve.getLoginByUserName(req, pobj, pobj.actionBody);
    if (tmpOpResult.status != 0) {
      return system.getResult(null, "创建用户信息失败");
    }
    pobj.userInfo = {
      channel_userid: actionBody.contactMobile,
      channel_username: actionBody.contactMobile,
      mobile: actionBody.contactMobile
    }

    // 询价
    pobj.actionBody.channelItemCode = "kjxg";
    pobj.actionBody.pathCode = "/kjfw/kjxg/";// 写死
    pobj.actionType = "getProductPrice";
    var url = settings.centerAppUrl() + "action/opProduct/springBoard";
    var productPriceResult = await this.restPostUrl(pobj, url);
    if (productPriceResult.status != 0) {
      return system.getResult(null, "productPrice is empty");
    }

    // addOrder
    pobj.actionBody.bizId = actionBody.bizId;
    pobj.actionBody.userName = actionBody.contactName;
    pobj.actionBody.mobile = actionBody.contactMobile;
    pobj.actionBody.orderNo = actionBody.bizId;
    pobj.actionBody.totalSum = productPriceResult.data.price;
    pobj.actionBody.orderPrice = productPriceResult.data.price;
    pobj.actionBody.payTotalSum = productPriceResult.data.price;
    pobj.actionBody.price = productPriceResult.data.price;
    pobj.actionBody.payCode = productPriceResult.data.payCode;
    pobj.actionBody.channelItemCode = productPriceResult.data.channelItemCode;
    pobj.actionBody.quantity = 1;
    pobj.actionBody.channelOrder = {
      channelServiceNo: actionBody.bizId,
      channelOrderNo: actionBody.bizId,
      orderStatus: 2
    }
    var orderrtn = await this.utilsOrderSve.addOrder(pobj, pobj.actionBody);
    if (orderrtn.status != 0 && orderrtn.status != -1) {
      return system.getResultFail(-5012, "订单创建失败");
    }
    console.log("创建服务单 order信息 start");
    console.log(orderrtn);
    console.log("创建服务单 order信息 end");
    if (orderrtn.data) {
      pobj.actionBody.orderNo = orderrtn.data.orderNo;
    }

    var deliveryObj = {
      actionBody: {
        "bizId":pobj.actionBody.bizId,
        "contactName":pobj.actionBody.contactName,
        "contactMobile":pobj.actionBody.contactMobile,
        "timeUnit":pobj.actionBody.timeUnit,
        "quantity":pobj.actionBody.quantity,
        "companyInfo":{
         "companyName":pobj.actionBody.companyInfo.companyName,
         "taxpayerType":pobj.actionBody.companyInfo.taxpayerType,
         "acctgSystemId":pobj.actionBody.companyInfo.acctgSystemId,
         "companyForm":pobj.actionBody.companyInfo.companyForm,
         "industry":pobj.actionBody.companyInfo.industry,
         "taxpayerNumber":pobj.actionBody.companyInfo.taxpayerNumber,
         "companyArea":pobj.actionBody.companyInfo.companyArea
        }
      },
      appInfo: pobj.appInfo
    }
    this.utilsPushSve.aliBusiness2Delivery(deliveryObj, "submitService");
    return system.getResultSuccess();
  }

}

module.exports = utils360Sve;
