const co = require("co");
var request = require("request");
const crypto = require('crypto');
const sha256 = require('sha256');
var urlencode = require('urlencode');
const system = require("../system");
class baiduClient {
  constructor() {
    this.pushlogSve = system.getObject("service.common.pushlogSve");
    this.execClient = system.getObject("util.execClient");
  }
  
  //2020 1027 laolan 调用百度网关
  async baiduPost( path, actionBody) {
    console.log('actionBody++',actionBody)
    let domain = "https://gwgp-mwnn9gk4o4e.i.bdcloudapi.com";
    let url = domain+path;
    let version ="bce-auth-v1";
    let accessKey = "ed0f5c4c7c2d4e87aa335d9b07bf9bd4";
    let secretKey = "f600c4e91f6d43998d637401e6e34ef9";
    let timestamp = new Date().toISOString()
    let site = timestamp.lastIndexOf(".");
    timestamp = timestamp.substring(0,site)+"Z"
    // let timestamp = "2020-11-05T04:00:00Z"
    console.log('timestamp++',timestamp)
    let signedHeaders = "host";
    let extime = 1800;
    // 因为是post，所以CanonicalQueryString为空
    // var signArr = [];
    // var keys = Object.keys(actionBody).sort();
    // if (keys.length == 0) {
    //   return system.getResult(null, "请求参数信息为空");
    // }
    // for (let k = 0; k < keys.length; k++) {
    //   const tKey = keys[k];
    //   if (tKey != "sign" && actionBody[tKey] && !(typeof (actionBody[tKey]) === "object")) {
    //     signArr.push(urlencode(tKey) + "=" + urlencode(actionBody[tKey]));
    //   }
    // }
    // let resultSignStr = signArr.join("&");
    // console.log('resultSignStr+++',resultSignStr)
    let canonicalHeaders = "host:gwgp-mwnn9gk4o4e.i.bdcloudapi.com"
    //中间结果1：规范化请求和前缀字符串
    let canonicalRequest = "POST" + "\n" + path + "\n" + "\n" + canonicalHeaders;
    console.log('canonicalRequest+++',canonicalRequest)
    //authStringPrefix(前缀字符串，由除sk字段外的签名信息生成)
    let authStringPrefix = version+"/"+accessKey+"/"+timestamp+"/"+extime;
    console.log('authStringPrefix+++',authStringPrefix)
    //中间结果2：派生签名密钥 signingKey
    let signingKey = crypto.createHmac('sha256', secretKey)
                   .update(authStringPrefix)
                   .digest('hex');
    console.log('signingKey+++',signingKey)
    //中间结果3：签名摘要 signature
    let signature = crypto.createHmac('sha256', signingKey)
                   .update(canonicalRequest)
                   .digest('hex');
    console.log('signature+++',signature)
    //最终结果：认证字符串 authorization
    let authorization = authStringPrefix+"/"+signedHeaders+"/"+signature;
    console.log('authorization+++',authorization)
    var baiduObj={
      authorization:authorization,
      data:actionBody
    }
    var rtn = await this.execClient.execBaiduPost(baiduObj, url);
    if (!rtn || !rtn.stdout) {
      return system.getResult(null, "execPost data is empty");
    }
    var result = JSON.parse(rtn.stdout);
    return result;
  }

  //百度接口 2020-10-27 laolan
  async baiduReqbyget(obj, cbk) {
    console.log('obj+++',obj)
    var path = obj.path;
    var reqbody = obj.reqbody;
    try {
      var res = await this.baiduPost( path, reqbody, {
        timeout: 10000, // default 3000 ms 修改3000为10000，原因ConfirmIcpIntention BizIds 超过5条会超时
        formatAction: true, // default true, format the action to Action
        formatParams: true, // default true, format the parameter name to first letter upper case
        method: 'POST', // set the http method, default is GET
        headers: {
          host:"gwgp-mwnn9gk4o4e.i.bdcloudapi.com"
        }, // set the http request headers
      });
      console.log('baidu++++res+++',res)
      this.pushlogSve.createDb({
        op: "new-baiduReqbyget",
        content: JSON.stringify(obj),//推送的参数信息
        resultInfo: JSON.stringify(res),
        returnType: '1',
        logLevel: '1',
        opTitle: "new-baiduReqbyget推送百度信息返回成功"
      });
      return system.getResultSuccess(res);
    } catch (e) {
      this.pushlogSve.createFailLogDb({
        appid: obj.appInfo ? obj.appInfo.uapp_id || "" : "",
        appkey: obj.appInfo ? obj.appInfo.uapp_key || "" : "",
        requestId: obj.requestId || "",
        content: JSON.stringify(obj),//推送的参数信息
        resultInfo: "error:" + JSON.stringify(e),
        clientIp: obj.clientIp || "",
        failType: 1,
        opTitle: "new-baiduReqbyget推送百度信息返回异常",
        pushNumber: obj.pushNumber || 1
      });
      return system.getResultFail(-200, "出现异常，error：" + e.stack);
    }
  }

  async test(){
    var obj={
      path:"/api/bla/provider/plan",
      reqbody:{
        "area" : "北京",
        "companyName" : "demoData",
        "companyAddress" : "demoData",
        "requirementId" : "TRE-nmnHtEoTjeE",
        "type" : "ICP"
      }
    };
    var actionBody = obj.reqbody;
    var path = obj.path;
    let domain = "https://gwgp-mwnn9gk4o4e.i.bdcloudapi.com";
    let url = domain+path;
    let version ="bce-auth-v1";
    let accessKey =  "ed0f5c4c7c2d4e87aa335d9b07bf9bd4";
    let secretKey = "f600c4e91f6d43998d637401e6e34ef9";
    let timestamp = new Date().toISOString();
    let signedHeaders = "host";
    let extime = 1800;
    var signArr = [];
    var keys = Object.keys(actionBody).sort();
    if (keys.length == 0) {
      return system.getResult(null, "请求参数信息为空");
    }
    for (let k = 0; k < keys.length; k++) {
      const tKey = keys[k];
      if (tKey != "sign" && actionBody[tKey] && !(typeof (actionBody[tKey]) === "object")) {
        signArr.push(urlencode(tKey) + "=" + urlencode(actionBody[tKey]));
      }
    }
    let resultSignStr = signArr.join("&");
    console.log('resultSignStr+++',resultSignStr)
    let canonicalHeaders = "host:gwgp-mwnn9gk4o4e.i.bdcloudapi.com"
    //中间结果1：规范化请求和前缀字符串
    let canonicalRequest = "POST" + "\n" + path + "\n" + resultSignStr + "\n" + canonicalHeaders;
    //authStringPrefix(前缀字符串，由除sk字段外的签名信息生成)
    let authStringPrefix = version+"/"+accessKey+"/"+timestamp+"/"+extime;
    //中间结果2：派生签名密钥 signingKey
    let signingKey = crypto.createHmac('sha256', secretKey)
                   .update(authStringPrefix)
                   .digest('hex');
    //中间结果3：签名摘要 signature
    let signature = crypto.createHmac('sha256', signingKey)
                   .update(canonicalRequest)
                   .digest('hex');
    //最终结果：认证字符串 authorization
    let authorization = authStringPrefix+"/"+signedHeaders+"/"+signature;
    var baiduObj={
      authorization:authorization,
      data:actionBody
    }
    var rtn = await this.execClient.execBaiduPost(baiduObj, url);
    if (!rtn || !rtn.stdout) {
      return system.getResult(null, "execPost data is empty");
    }
    var result = JSON.parse(rtn.stdout);
    if(!result || !result.result ){
      return system.getResultFail("推送失败");
    }
    return system.getResultSuccess();
  }
}
module.exports = baiduClient;
